#!/usr/bin/env python3

import sys
import random

class Node:
    def __init__(self, val):
        self.data = val
        self.left  = None
        self.right = None

# The tree CANNOT contain duplicate values
class BinaryTree:
    def __init__(self):
        self.root = None

    def insertNode(self, val):
        self.root = self._insertNode(self.root, val)

    def _insertNode(self, node, val):
        if node is None:
            return Node(val)

        if val == node.data:
            return node

        # This is where we prevent duplicate values
        # No == case is considered
        if val < node.data:
            node.left = self._insertNode(node.left, val)
        elif val > node.data:
            node.right = self._insertNode(node.right, val)
        return node

    def nLeafNodes(self, node): 
        if node is None: 
            return 0 
        if (node.left is None and node.right is None): 
            return 1 
        else: 
            return self.nLeafNodes(node.left) + self.nLeafNodes(node.right)

if len(sys.argv) != 2:
    print("./leafNodes.py NUMBER_OF_NODES")
    sys.exit()

nodes = int(sys.argv[1])
min = 0
max = nodes

myArray = []
for x in range(min, max):
    myArray.append(x)
random.shuffle(myArray)

bt = BinaryTree()
for myInt in myArray:
    bt.insertNode(myInt)

print(bt.nLeafNodes(bt.root))
