#!/usr/bin/env python3

import random
import sys

class Node:
    def __init__(self, val):
        self.data = val
        self.left = None
        self.right = None

def insertNode(root, node):
    if root is None:
        root = node
    else:
        if root.data > node.data:
            if root.left is None:
                root.left = node
            else:
                insertNode(root.left, node)
        elif root.data < node.data:
            if root.right is None:
                root.right = node
            else:
                insertNode(root.right, node)
        else:
            return

def search(root, value):
    if root is None:
        return False
    else:
        if root.data > value:
            if root.left is None:
                return False
            else:
                return search(root.left, value)
        elif root.data < value:
            if root.right is None:
                return False
            else:
                return search(root.right, value)
        else:
            return True

if len(sys.argv) != 3:
    print("./traverse.py NUMBER_OF_NODES SEARCH_VALUE")
    sys.exit()

nodes = int(sys.argv[1])
searchValue = int(sys.argv[2])

min = 0
max = nodes

myArray = []
for x in range(min, max):
    myArray.append(x)

random.shuffle(myArray)
myRoot = Node(myArray[0])
print("Going to insert:", myArray)

for myInt in myArray:
    insertNode(myRoot, Node(myInt))

if search(myRoot, searchValue):
    print("Found", searchValue)
else:
    print("Not found", searchValue)
