#!/usr/bin/env python3

import random
import sys

class Node:
    def __init__(self, val):
        self.data = val
        self.left = None
        self.right = None

def insertNode(root, node):
    if root is None:
        root = node
    else:
        if root.data > node.data:
            if root.left is None:
                root.left = node
            else:
                insertNode(root.left, node)
        elif root.data < node.data:
            if root.right is None:
                root.right = node
            else:
                insertNode(root.right, node)
        else:
            return

def traverse(root):
    if not root:
        return        
    print(root.data, end=" ")
    traverse(root.left)
    traverse(root.right)

if len(sys.argv) != 2:
    print("./traverse.py NUMBER_OF_NODES")
    sys.exit()

nodes = int(sys.argv[1])

min = 0
max = nodes

myArray = []
for x in range(min, max):
    myArray.append(x)

# Make the array random
random.shuffle(myArray)

myRoot = Node(myArray[0])
print("Root node:", myRoot.data)
print("Going to insert:", myArray)

for myInt in myArray:
    insertNode(myRoot, Node(myInt))

traverse(myRoot)
print("")
